(** Aide pour le TP 7 *)

exception Error of string

val error : string -> string -> 'a
(** [error err msg] lve l'exception Error avec le message ["err: msg"] *)

val handle_error : ('a -> 'b) -> 'a -> 'b
(** [handle_error f x] excute l'application [f x].
    Si l'exception [Error] est leve par l'excution de [f x], le
    message associ  l'exception est affich et le programme
    s'arrte.
*)

val retransmit : Unix.file_descr -> Unix.file_descr -> unit
(** [retransmit fd_in fd_out] recopie sur le descripteur [fd_out] tout
    ce qui est lu sur le descripteur [fd_in].
*)

val parse_url : string -> (string * int) * string
(** [parse_url] extrait d'un chane de caractres de la forme
    ["http://machine:port/chemin"] le couple [(machine, port)] et
    la chane ["/chemin"].
    S'il n'y a pas de numro de port spcifi dans l'url, la valeur
    [80] est retourne.
*)

val parse_get : string -> string
(** [parse_get] extrait d'un chane de caractres de la forme
    ["GET url HTTP/1.?"] la partie [url].
*)

val parse_response : string -> int * string
(** [parse_response] extrait d'un chane de caractres de la forme
    ["HTTP/1.? code message"] les parties [code] et [message].
*)

val parse_header : string -> string * string
(** [parse_header] extrait d'un chane de caractres de la forme
    ["field: value"] le couple [(field, value)].
*)
